from Utils import Utils
import os

## Classe Menu
# Affichage principal de l'application du squelette
# Toutes les interactions utilisateur sont effectuées ici
from UtilsGit import UtilsGit


class Menu:
    auteurEnCours = 0

    ## Constructeur, permet de lancer le 1er menu

    def __init__(self):
        # obligatoire à faire au début
        Utils.initialiseMongo()
        self.menuDeBase()

    ##  1er menu affiché et proposé à l'utilisateur
    #    Permet de choisir un "compte"
    #    (Version spéciale pour le squelette)
    def menuDeBase(self):
        os.system('clear')
        # temporaire, juste pour la création du squelette
        print("Choisir votre numéro d'auteur")
        print("1 : Auteur 1")
        print("2 : Auteur 2")
        print("3 : Auteur 3")
        print("Votre choix : ")
        choix = (input())

        if choix == 'p':
            Utils.toutPeter()
            self.menuDeBase()
        if choix.isdigit():
            auteur = Utils.switchAuteur(int(choix))
            if auteur != "Auteur inconnu":

                if Utils.presenceUtilisateur(auteur):
                    self.auteurEnCours = auteur
                    self.menuDesActions()
        else:
            print("Mal")

    ##    Menu affiché une fois un compte valide sélectionné

    def menuDesActions(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)
        print("Choisir l'action : ")
        print("0 : Importer un contenu")
        print("1 : Consulter le panier")
        print("2 : Aller à la banque de contenu")
        print("3 : Revenir au menu")
        print("4 : Supprimer un contenu")
        print("5 : Créer une évaluation")
        print("6 : Consulter les évaluations")
        print("7 : Modifier un contenu")
        print("8 : Naviguer dans un contenu")
        print("9 : Rechercher un contenu")
        print("10 : Consulter les contenus en cours de modification")
        print("11 : Gérer les demandes de publication")
        print("12 : Mises à jour de favoris")
        print("Votre choix : ")
        choix = (input())
        if choix.isdigit():
            self.switchActions(int(choix))

    ##  Permet de récupérer l'action désirée par l'utilisateur

    def switchActions(self, argument):
        if argument == 0:
            self.importFichier()
        elif argument == 1:
            self.consulterPanier()
        elif argument == 2:
            self.consulterBanque()
        elif argument == 3:
            self.menuDeBase()
        elif argument == 4:
            self.supprimerContenu()
        elif argument == 5:
            self.creerEvaluation()
        elif argument == 6:
            self.consulterEvaluations()
        elif argument == 7:
            self.modifierContenu()
        elif argument == 8:
            self.naviguerContenu()
        elif argument == 9:
            os.system('clear')
            print("Bonjour ", self.auteurEnCours)
            print("Fonctionnalité à venir")
        elif argument == 10:
            self.consulterEnCours()
        elif argument == 11:
            self.gererDemandesPublication()
        elif argument == 12:
            self.majFavoris()
        else:
            print("Action inconnue")

    ##   Importer un fichier (action 0)

    def importFichier(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)
        print("Selectionner le fichier à charger")
        print("1 : Contenu1")
        print("2 : Contenu2")
        print("3 : Revenir en arrière")
        print("Votre choix : ")
        choix = (input())
        if choix.isdigit():
            self.switchFichiers(int(choix))

    ##    En fonction du choix effectué dans importFichier, on charge le fichier choisi

    def switchFichiers(self, argument):
        if argument == 1 or argument == 2:
            Utils.ajouterContenu("Contenu" + str(argument), self.auteurEnCours)
            self.consulterPanier()
        elif argument == 3:
            self.menuDesActions()
        else:
            print("Fichier inexistant")

    ##    Consulter le panier (action 1)
    def consulterPanier(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)

        # 1. On charge les contenus "propres" de la banque
        questions = Utils.consulterContenu(self.auteurEnCours, True)
        print(self.auteurEnCours + " possede " + str(questions.count()) + " contenu(s)")
        if questions.count() > 0:
            self.afficherContenus(questions)
        # 1. On charge les contenus "mis en favori" de la banque

        print(f"Contenus mis en favori par l'auteur {self.auteurEnCours} : {len(Utils.getFavoris(self.auteurEnCours))}")

        if len(Utils.getFavoris(self.auteurEnCours)):
            for (id, version) in Utils.getFavoris(self.auteurEnCours):
                print("La question : ", int(id['contenu']), " et sa version", int(version['version']))
                self.afficherContenusFavoris(
                    Utils.getContenuavecIdEtVersion(int(id['contenu']), int(version['version'])),
                    int(version['version']))
        print("Appuyer sur q pour revenir en arriere")
        choix = (input())
        if choix == 'q':
            self.menuDesActions()

    ##    Consulter la banque (action 2)
    def consulterBanque(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)

        # on charge tous les contenus n'appartenant pas à l'utilisateur (qu'il peut retrouver dans son panier)
        questions = Utils.consulterContenu(self.auteurEnCours, False)
        print("La banque possède actuellement", questions.count(), " contenu(s)")
        if questions.count() > 0:
            self.afficherContenusBanque(questions)

            # on propose à l'utilisateur de mettre en favori les contenus de la banque
            print("Entrer l'id de la question à mettre en favori ou appuyer sur q pour revenir en arriere")
            choix = (input())
            if choix == 'q':
                self.menuDesActions()
            elif choix.isdigit():
                print("Je veux favoriser la question ", choix, " et je suis l'auteur ", self.auteurEnCours)
                Utils.mettreContenuEnFavori(choix, self.auteurEnCours)
                self.consulterPanier()
            else:
                print("On t'a dit q ou un un chiffre sérieux :<")
        else:
            print("Appuyer sur q pour revenir en arriere")
            choix = (input())
            if choix == 'q':
                self.menuDesActions()

    ##    Fonction d'affichage des contenus 'panier personnel'

    def afficherContenus(self, contenu):

        for elt in contenu:
            print("nom :", elt["fichier"], " - v", elt["versionEnCours"]["numero"], " - du",
                  elt["versionEnCours"]["date"])

    ##    Fonction d'affichage des contenus 'banque'
    def afficherContenusBanque(self, contenu):

        favoris = Utils.getFavoris(self.auteurEnCours)
        is_fav = False
        #print("favoris : ", favoris)

        for elt in contenu:
            print("id :", elt["id"], "auteur :", elt["auteur"], " - nom :", elt["fichier"], " - v",
                  elt["versionEnCours"]["numero"], " - du",
                  elt["versionEnCours"]["date"], end='')
            is_fav = False

            for fac in favoris:
                if elt["id"] == fac[0]["contenu"]:
                    print(f' (* v{fac[1]["version"]})')
                    is_fav = True
            if not is_fav:
                print("\r")

    ##    Fonction d'affichage des contenus 'favoris'
    def afficherContenusFavoris(self, contenu, version):

        # print (contenu)

        print("id :", contenu["id"], "auteur :", contenu["auteur"], " - nom :", contenu["fichier"], " - v",
              version, " - du",
              contenu["versionEnCours"]["date"])

    ##    Fonction d'affichage des contenus 'en cours de modification'
    def afficherContenusEnCours(self, contenu):

        en_cours = Utils.getContenusEnCours(self.auteurEnCours)

        print("Je veux afficher", en_cours.count(), "contenus en cours")

        for elt in en_cours:
            print("id Modif :", elt["idContenuEC"], "auteur original :", elt["auteur"], " - id Original :",
                  elt["reference"],
                  "version original", elt["version"], " date modif ", elt["date"])

    ##    Supprimer un contenu  (permet de dissocier son auteur) (action 4)

    def supprimerContenu(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)

        print("1. Supprimer un contenu personnel")
        print("2. Supprimer un favori")
        print("3. Revenir en arrière")

        choix = int(input())
        if choix == 1:
            self.supprimerContenuPersonnel()
        elif choix == 2:
            self.supprimerContenuFavori()
        else:
            self.menuDesActions()

    ##    Supprimer un contenu - Fonction spécifique contenu personnel (action 4)

    def supprimerContenuPersonnel(self):
        # On charge les contenus de l'auteur en cours (si existants)
        questions = Utils.consulterContenu(self.auteurEnCours, True)
        print(self.auteurEnCours + " possede " + str(questions.count()) + " contenu(s)")
        if questions.count() > 0:
            self.afficherContenusBanque(questions)

        print("Entrer l'id du contenu à supprimer ou appuyer sur q pour revenir en arriere")
        choix = (input())
        if choix == 'q':
            self.supprimerContenu()

        # on charge la fonction de "suppression" d'un contenu en fonction de la saisie de l'utilisateur
        if choix.isdigit():
            print("Le contenu choisi a ", int(choix), "favoris liés")
            if Utils.existeEnFavori(int(choix)):
                Utils.supprimerContenu(int(choix))
                self.consulterPanier()
            else:
                Utils.aneantirContenu(int(choix))
                self.consulterPanier()

    ##    Supprimer un contenu - Fonction spécifique contenu favori (action 4)

    def supprimerContenuFavori(self):

        favoris = dict()
        print(self.auteurEnCours, " possede ", len(Utils.getFavoris(self.auteurEnCours)), " favori(s)")

        # On charge les contenus de l'auteur en cours (si existants)
        if len(Utils.getFavoris(self.auteurEnCours)):
            for (id, version) in Utils.getFavoris(self.auteurEnCours):
                print("La question : ", id["contenu"], " et sa version", version["version"])
                self.afficherContenusFavoris(Utils.getContenuavecIdEtVersion(id["contenu"], version["version"]),
                                             version["version"])
                favoris[id["contenu"]] = version["version"]

        print("Entrer l'id du contenu à supprimer ou appuyer sur q pour revenir en arriere")
        choix = (input())
        if choix == 'q':
            self.supprimerContenu()

        # on charge la fonction de "suppression" d'un contenu en fonction de la saisie de l'utilisateur
        if choix.isdigit():
            print("Le contenu choisi a ", int(choix), "favoris liés. Sa version associée est : ", favoris[int(choix)])
            Utils.supprimerFavori(int(choix), self.auteurEnCours, favoris[int(choix)])
            print("Le favori ", int(choix), " a été supprimé")
            print("nombre : ", Utils.existeEnFavori(int(choix)))
            print("anonyme : ", Utils.isAnonyme(int(choix)))

            if Utils.existeEnFavori(int(choix)) and Utils.isAnonyme(int(choix)):
                Utils.aneantirContenu(int(choix))
                print("Le contenu ", int(choix), " a été définitivement supprimé")

    ##    Créer une evaluation (regroupement de contenu) (action 5)
    def creerEvaluation(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)

        # on charge tous les contenus présents
        questions = Utils.consulterTousLesContenu()
        if questions.count() > 0:
            self.afficherContenusBanque(questions)
        print("Nombre de contenus à ajouter : (entre 1 et ", Utils.getMaxIdContenus(),
              "), q pour revenir en arrière")
        choix = (input())

        questions = list()
        if choix == 'q':
            self.menuDesActions()
        if choix.isdigit():
            print(int(choix), "questions dans l'éval")
            # en fonction de la saisie précédente on invite l'utilisateur à entrer ses numéros de contenu
            for i in range(int(choix)):
                print("Contenu ", i + 1, ", donner l'id du contenu :")
                questions.append(int(input()))
            print("Contenus(s) choisi(s) : ", questions)
            Utils.creerEvaluation(questions, self.auteurEnCours)
            self.consulterEvaluations()

    ##    Consulter les évaluations pour l'auteur en cours (action 6)
    def consulterEvaluations(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)

        print("L'auteur ", self.auteurEnCours, " a ", Utils.getEvaluations(self.auteurEnCours).count(), " evaluations")
        self.afficherEvaluations(Utils.getEvaluations(self.auteurEnCours))
        print("Entrer un id pour supprimer une évaluation ou Appuyer sur q pour revenir en arriere")
        choix = (input())
        if choix == 'q':
            self.menuDesActions()
        if choix.isdigit():
            # print("Je veux modifier la question : ", choix)
            Utils.supprimerEvaluation(choix)
            print("Contenu supprimé")
            self.consulterEvaluations()

    ##    Afficher le détail des évaluations d'un auteur
    def afficherEvaluations(self, evaluations):
        for elt in evaluations:
            print("n°", elt["idEval"], " - date", elt["date"], " - contenus : ", end='')
            for i in range(len(elt["contenu(s)"])):
                print(i + 1, " ", end='')
            print("\r")

    ##    Afficher le détail des évaluations d'un auteur (action 7)
    def modifierContenu(self):

        os.system('clear')
        print("Bonjour ", self.auteurEnCours)

        contenuPerso = Utils.consulterContenu(self.auteurEnCours, True)
        favoris = Utils.getFavoris(self.auteurEnCours)

        # 1. Les contenus personnels
        print("Vous avez", contenuPerso.count(), "questions à vous en banque : ")
        if contenuPerso.count() > 0:
            self.afficherContenusBanque(contenuPerso)

        # 2. Les contenus "favoris"
        print("Et ", len(favoris), "favoris")
        if len(favoris) > 0:
            for (id, version) in favoris:
                self.afficherContenusFavoris(Utils.getContenuavecIdEtVersion(id["contenu"], version["version"]),
                                             version["version"])
        # si aucune question dans le panier on n'offre pas la possibilité d'en choisir une
        if contenuPerso.count() == 0 and len(favoris) == 0:
            phrase = "Appuyer sur q pour revenir en arriere"
        else:
            phrase = "Entrez le numéro de la question à modifier ou Appuyer sur q pour revenir en arriere"
        print(phrase)
        choix = (input())

        if choix == 'q':
            self.menuDesActions()
        # si un chiffre a été saisi on va charger la modif de question pour cet id (les filtres viendront + tard)
        if choix.isdigit():
            print("Je veux modifier la question : ", choix)
            Utils.modifierContenu(choix, self.auteurEnCours)
            self.consulterEnCours()

    ## Contenus en cours de modification. Seront par la suite intégrés au panier
    def consulterEnCours(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)
        contenus = Utils.getContenusEnCours(self.auteurEnCours)
        print("Vous avez ", contenus.count(), "contenu(s) en cours de modification")
        if contenus.count() > 0:
            self.afficherContenusEnCours(contenus)
        print("Entrer l'id du contenu en cours, puis une lettre d'action (ou directement q pour quitter)")
        print("c pour consulter le contenu")
        print("m pour modifier le contenu")
        print("s pour supprimer le contenu")
        print("v pour valider la modification du contenu (sous réserve)")
        print("n pour créer un nouveau contenu")

        choix = input()

        id = 0
        action = ""

        if choix == "q":
            self.menuDesActions()
        if len(choix) < 2 or choix[len(choix) - 1:].isdigit():
            self.consulterEnCours()
        else:
            id = int(choix[:len(choix) - 1])
            action = choix[len(choix) - 1:]

            print("id :", id)
            print("action :", action)
            print("action c :", action == 'c')

        idContenu = Utils.getIdContenuAssocieAUnEnCours(int(id))

        print("id contenu associé : ", idContenu)

        # affiche le contenu courant du fichier
        if action == 'c':
            print("je suis dans action c")

            Utils.changerVersion(idContenu, 0, Utils.getBrancheContenuEnCours(idContenu))
            # exit(0)
            Utils.affichage(Utils.getCheminDuContenu(idContenu))
            # print("Uoi")

        elif action == 'm':
            Utils.changerVersion(idContenu, 0, Utils.getBrancheContenuEnCours(idContenu))
            Utils.modifierContenu(idContenu, self.auteurEnCours, True)
            Utils.affichage(Utils.getCheminDuContenu(idContenu))
        elif action == 's':
            Utils.supprimerContenuEnCours(int(id))
        elif action == 'v':
            self.validerModification(int(id))
            Utils.supprimerContenuEnCours(int(id))

        elif action == 'n':
            contenu_associe = Utils.getIdContenuAssocieAUnEnCours(int(id))
            chemin = Utils.getCheminDuContenu(contenu_associe)

            Utils.creerNouveauContenu(chemin,
                                      self.auteurEnCours, id)
            if Utils.isFavoriDeAuteur(self.auteurEnCours, contenu_associe):
                versionFavori = Utils.getVersionFavoriById(contenu_associe, self.auteurEnCours)
                Utils.supprimerFavori(contenu_associe, self.auteurEnCours, versionFavori)
            self.consulterPanier()
        elif action == 'q':
            self.menuDesActions()

    ## changement de version d'un contenu OU demande de publication à l'auteur d'origine

    def validerModification(self, idContenuEnCours):

        # on récupère l'auteur et l'id du contenu "de base" associé à la modif
        auteur = Utils.getAuteurContenuEnCours(idContenuEnCours)
        idContenu = Utils.getIdContenuAssocieAUnEnCours(idContenuEnCours)
        branche = Utils.getBrancheContenuEnCours(idContenuEnCours)

        print("L'auteur en cours est : ", self.auteurEnCours)
        print("L'auteur de base est : ", auteur)

        if auteur == self.auteurEnCours:
            print("Modification directe d'un auteur")
            chemin = Utils.getCheminDuContenu(idContenu)
            Utils.majContenu(chemin, idContenu, branche)
        else:
            print("Modification indirecte -> demande de publication")
            print("Je demande à l'auteur ", auteur, "de valider ma demande de proposition")
            Utils.demandePublication(idContenu, idContenuEnCours, self.auteurEnCours, auteur)
            self.menuDesActions()

    ## Naviguer entre différentes versions d'un contenu - Action 8
    def naviguerContenu(self):
        print("Cette fonction servira à consulter différentes versions d'un contenu")
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)

        # 1. On charge les contenus "propres" de la banque
        questions = Utils.consulterContenu(self.auteurEnCours, True)
        nbreQuestion = questions.count()
        print(self.auteurEnCours + " possede " + str(nbreQuestion) + " contenu(s)")
        if questions.count() > 0:
            self.afficherContenusBanque(questions)
        # 1. On charge les contenus "mis en favori" de la banque

        print(f"Contenus mis en favori par l'auteur {self.auteurEnCours} : {len(Utils.getFavoris(self.auteurEnCours))}")
        nbreFavoris = len(Utils.getFavoris(self.auteurEnCours))
        if len(Utils.getFavoris(self.auteurEnCours)):
            for (id, version) in Utils.getFavoris(self.auteurEnCours):
                print("La question : ", int(id['contenu']), " et sa version", int(version['version']))
                self.afficherContenusFavoris(
                    Utils.getContenuavecIdEtVersion(int(id['contenu']), int(version['version'])),
                    int(version['version']))
        if nbreFavoris > 0 or nbreQuestion > 0:
            print ("Entrer le numero de contenu désiré (ou q pour quitter)")
            choix = input()
            if choix == 'q':
                self.menuDesActions()
            if choix.isdigit():
                print ("La question qui m'intéresse est la : ", int(choix))
                print ("Cette question en est à la version : ", Utils.getVersionCourante(int(choix)))
                if Utils.getVersionCourante(int(choix)) == 1:
                    print ("Aucun choix, j'affiche juste la version en cours")
                    Utils.affichage(Utils.getCheminDuContenu(int(choix)))
                else:
                    contenu = int(choix)
                    print ("Je choisis la version que je veux : (entre 1 et", Utils.getVersionCourante(int(choix)), ")")
                    choix = int(input())
                    print ("Je veux charger la version ", choix)
                    #commitVersion = Utils.getCommitPourUneVersion(choix, contenu)
                    Utils.changerVersion(contenu, choix)


    ## Gérer les demandes de publication emises et recues - Action 11
    def gererDemandesPublication(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)
        print("1. Demandes de publication emises")
        print("2. Demandes de publication reçues")
        print("3. Revenir en arrière")

        choix = int(input())
        if choix == 1:
            contributions = Utils.getDemandesPub(self.auteurEnCours)
            print("Je veux afficher les contributions emises, j'ai ", contributions.count(), "contributions")
            if contributions.count() > 0:
                self.afficherDdePublications(contributions, True)
            else:
                print("Vous n'avez aucune demande de contribution emise, appuyez sur q pour revenir en arriere")
                input()
                self.gererDemandesPublication()
        elif choix == 2:
            contributions = Utils.getDemandesPub(self.auteurEnCours, False)
            print("Je veux afficher les contributions recues, j'ai ", contributions.count(), "contributions")
            if contributions.count() > 0:
                self.afficherDdePublications(contributions, False)
            else:
                print("Vous n'avez aucune demande de contribution emise, appuyez sur q pour revenir en arriere")
                input()
                self.gererDemandesPublication()
        elif choix == 3:
            self.menuDesActions()

    ## Affichage des demandes de publication
    # @param emetteur -> l'auteur est le demandeur de la publication si True, et le réceptionnaire si False
    def afficherDdePublications(self, publications, emetteur):
        if not emetteur:
            texte = "auteur demandeur : "
            for pub in publications:
                etat = pub["etat"]
                # pour raison de simplicité, les demandes de publication refusées sont invisibles (dans un futur proche elle seront visibles mais non interactives)
                if etat != "refus":
                    print(texte, pub["auteurDemande"], "idDemandePublication : ", pub["id"], "date : ", pub["date"])
            print("Entrer l'id de la publication puis O ou N pour accepter ou refuser la demande")
            choix = input()
            num_contenu = choix[0:len(choix) - 1]
            choix = choix[len(choix) - 1:]
            Utils.gererDemandePub(num_contenu, choix)
        else:
            texte = "auteur source : "
            for pub in publications:
                id_pub = pub["id"]
                print(texte, pub["auteurContenu"], "idDemandePublication : ", pub["id"], "date : ", pub["date"],
                      "etat : ", pub["etat"])
                if pub["etat"] == "refus":
                    print("Actions possibles : ")
                    print("n : creer un nouveau contenu a partir de celui ci")
                    print("s : supprimer le contenu")
                    print("q : remettre ce choix à plus tard")
                    choix = input()
                    if choix == 'n':
                        id_en_cours = Utils.getIdContenuEnCoursAssocieAUnePublication(id_pub)
                        contenu_associe = Utils.getIdContenuAssocieAUnEnCours(id_en_cours)
                        chemin = Utils.getCheminDuContenu(contenu_associe)

                        Utils.creerNouveauContenu(chemin,
                                                  self.auteurEnCours, id_pub)
                        if Utils.isFavoriDeAuteur(self.auteurEnCours, contenu_associe):
                            versionFavori = Utils.getVersionFavoriById(contenu_associe, self.auteurEnCours)
                            Utils.supprimerFavori(contenu_associe, self.auteurEnCours, versionFavori)
                        self.consulterPanier()
                    elif choix == 's':
                        Utils.supprimerContenuEnCours(Utils.getIdContenuEnCoursAssocieAUnePublication(pub["id"]))
                    elif choix == 'q':
                        self.menuDesActions()

    ## Observer les possibilités de mettre à jour les favoris - Action 12
    def majFavoris(self):
        os.system('clear')
        print("Bonjour ", self.auteurEnCours)
        nbreFavoris = len(Utils.getFavoris(self.auteurEnCours))
        print("L'auteur possède ", nbreFavoris, " favoris")
        if nbreFavoris > 0:
            Utils.listeMajFavoris(self.auteurEnCours)
        else:
            print("Vous n'avez aucun favori, appuyez sur q pour revenir en arriere")
            input()
            self.menuDesActions()
